﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net.Http;
using System.Net.Http.Headers;
using System.IO;
using System.Diagnostics;

namespace CreatePackageFromTemplateReplacingPlaceholderREST
{
    class Class1
    {
        private static string key = "api_key";
        private static string url = "https://sandbox.esignlive.com/api";

        public static void Main(string[] args)
        {
            string packageId = "ncE7Lf7h9EMvqEm7FMayLvJTJ68=";
            string jsonString = "{\"name\":\"Package created from template through REST API\",\"description\":\"Package created with the eSignLive REST API\",\"emailMessage\":\"This message should be delivered to all signers\",\"autocomplete\":true,\"type\":\"PACKAGE\",\"visibility\":\"ACCOUNT\",\"due\":null,\"language\":\"en\",\"status\":\"DRAFT\",\"roles\":[{\"id\":\"PlaceholderId1\",\"type\":\"SIGNER\",\"signers\":[{\"id\":\"PlaceholderId1\",\"firstName\":\"Patty\",\"lastName\":\"Gallant\",\"email\":\"patty.galant@mailinator.com\"}],\"name\":\"PlaceholderId1\"}]}";
            StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");

            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", key);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");

            var response = myClient.PostAsync(new Uri(url) + "/packages/" + packageId + "/clone", jsonContent).Result;
            Debug.WriteLine(response.Content.ReadAsStringAsync().Result);
        }
    }
}
